#!/usr/bin/ruby
#
# Copyright (c) 2004, Dr Balwinder S Dheeman <bsd/AT/rubyforge.org>

if ARGV.length < 1
    printf "usage: %s <upsN[@hostname]>\n", File.basename(__FILE__)
    exit
end

require "socket"
require "timeout"
require "config"

conf = Config::read "/etc/nut/upsd.users"
passwd = conf.value("cacti", "password")

ups, host = ARGV[0].split("@")
host = host ? host : "localhost"
begin
    timeout(30) do
	$s = TCPsocket.open(host, 3493)
    end
    rescue Errno::ECONNREFUSED
    rescue Errno::EHOSTUNREACH || Errno::ENETUNREACH
    rescue Errno::SocketError
    rescue Errno::TimeoutError
else
    $s.write("USERNAME cacti\r\n"); $s.readline
    $s.write("PASSWORD #{passwd}\r\n"); $s.readline
    $s.write("GET VAR #{ups} ups.status\r\n")
    $s.readline; $_ =~ /.*\s"(.*)"$/; stat = $1    
    $s.write("GET VAR #{ups} battery.charge\r\n")
    $s.readline; $_ =~ /.*\s"(.*)"$/; blvl = $1
    $s.write("GET VAR #{ups} input.voltage\r\n")
    $s.readline; $_ =~ /.*\s"(.*)"$/; ivol = $1
    $s.write("GET VAR #{ups} output.voltage\r\n")
    $s.readline; $_ =~ /.*\s"(.*)"$/; ovol = $1
    $s.write("GET VAR #{ups} ups.load\r\n")
    $s.readline; $_ =~ /.*\s"(.*)"$/; load = $1
    $s.write("GET VAR #{ups} ups.temperature\r\n")
    $s.readline; $_ =~ /.*\s"(.*)"$/; temp = $1
    $s.write("LOGOUT\r\n")
    $s.close
    printf "blvl:%s ivol:%s load:%s ovol:%s stat:%s temp:%s",
	blvl, ivol, load, ovol, 1, temp
end
